# Jovansonlee B. Cesar
## Senior Software Engineer

Opensource programmer with passion for innovative technologies

 * mobile: +639156659318
 * email: ivanceras@gmail.com
 * skype: ivanceras

## Expertise

* Data analytics and visualization
* Heuristic programming on complex problems
* High availability and scaling solutions
* Code quality and code correctness
* Research and development

## Preferred Technology Stack
* Linux, Rust, PostgreSQL, Webassembly


## All Technology Stack
* Linux, **Rust**, PostgreSQL, Java, Php, Bash/Shell, Docker
* Javascript, HTML/CSS, **Elm**, **Webassembly**, React, React-native
* **PostgreSQL**,Mysql,Oracle,SQLite, Hadoop/Hive/MapReduce
* git, vim, Eclipse, IntelliJ
* xls+ods+csv data processing


## Professional Work Experience

* **Centrifuge Inc (March 2020 - Present)**
    - Centrifuge-chain protocol engineer
    - Responsibilities:
        - Build and integrate substrate pallet/modules into centrifuge-chain
        - Build and integrate monitoring tools for blockchain validators and nodes
    - Technologies used:
        - **rust**, blockchain, cryptography, **paritytech/substrate**, polkadot network, prometheus + grafana, bash scripting


* **Freelancing and opensource (May 2019 - Dec 2019)**
    - Self study rust and freelance contracts.
    - Projects:
        - **dns gateway module** - an independent contract project which manages and automate acquisition of ssl certificates from lets-encrypt.
            - dynamically serve multiple domains in one server using the appropriate certificate for the requested domain.
            - involves low level parsing of tcp-packets, extracting the SNI/domain name in the handshake process.
        - **open-api parser** - generates rust source code from open-api spec.

    - Technolgoies used:
        - **rust**, tokio, actix-web, rustls

* **Senior Software Engineer at Copyleft Solutions (Jun 2017 - Dec 2018)**

    - Involvement
        - Fix and maintain existing android applications
        - Port excel spreadsheet apps into web application
        - Prototype small experimental projects involving webcam and image processing
        - Screened and interview talented developers into the company

    - Technologies used
        - Android/Java, typescript
        - Rust, gtk

* **Senior Software Engineer at TRUSTe/TrustArc (Jan 2012-Jun 2017)**

    - Projects
        - Multi-region database selective syncing setup.
            - Setup custom configuration to selectively sync certain data from EU-US region, while complying the EU regulations
            of which data is not allowed to move out of EU servers.
       - Created a custom lightweight ORM which doesn't allow loss of data in the event of database downtime up to several hours.

    - Involvement
        - Prototype and build critical products in the organization, such as the portal which links all the apps in the organization.
        - Design database schema for high throughput application, such as the backend for ads system.
        - Research and development on processing 1TB of logs per month into an analytical report, using appropriate BigData Analytics tools such as Hadoop/Hive.
        - Implemented a sophisticated requirement to do selective synchronization of data into multiple database instances from different regions, in accordance to US and EU data regulations.
        - Brought the database to terabyte scale, making it to the top 5 AWS apps in terms of page impression.
        - Data recovery and correction through scraping out logs from the production servers, in the event of unexpected data loss.
        - Completed an backend service for doing static and dynamic analysis of ios apps.
        - Implemented a project involving document search using amazon ElasticSearch.

    - Skills used
        - **Java**, GWT, Amazon EMR, Amazon SDK(lambda, s3, elasticsearch)
        - Javascript, Angularjs, jquery, bootstrap
        - PostgreSQL, SymmetricDS, SQLite
        - Rust, python, C, bash



 * **Senior Software Engineer at Cebu Machine Laboratories Inc. (Oct. 2010 - Jan. 2012)**

    - Involvement
        - Research and prototype an Interactive Comic Game for the Ipad when it first came out.
        - Using C, Objective-C and opengl, animate 2D assets created by the artist.

    - Accomplishments
        - Used stencil and svg overlay on the 2D images, presented as a very simple solution to animate 2D images for an interactive comic game.



 * **Junior Software Engineer at Cebu Mitsumi Inc. (Apr 2007 - Aug 2009)**

    - Involvement
        - Maintain and improve an existing Shop Floor Control/Manufacturing Management Software.
        - Improved the existing UI and UX to reduce the number of actions to accomplish tasks.
        - Improved the flexibility of the report generator to provide a more detailed view of the data into an interactive excel spreadsheet.

    - Skill used
        - Oracle
        - Powerbuilder, Powerscripts
        - MS Excel Spreadsheet, VBA scripts and macros.



## Education
* **Bohol Island State University ( 2002-2007 ), C.P.G North Avenue, Tagbilaran City, Bohol**
    - Bachelor of Science in Computer Engineering
    - Learning highlights
        - Linux
        - C, Lowlevel-C Programming, PIC
        - Hardware interfacing
        - Self-taught: php, javascript, html/css.

## Desirable qualities
- I do research, experiments, exploration on my free-time on just about anything
ranging from database tools, neat algorithmns, learning programming languages,
voxel-based raytracing, baremetal OS.
- Incorporate these learnings into company products.

## Opensource project involvement

* [Svgbob](https://github.com/ivanceras/svgbob) - converts inline ascii scribbles and diagrams into a nicely rendered svg,
       [demo](https://ivanceras.github.io/svgbob-editor/)
* [Diwata](https://github.com/ivanceras/diwata) - A user-friendly web-based database administration tool for PostgreSQL and Sqlite
* [Rustorm](https://github.com/ivanceras/rustorm) - an orm for rust, primarily used by the diwata project.
* [Sauron](https://github.com/ivanceras/sauron) - A very fast library for building web apps, using the latest web technology: webassembly.
* [Restq](https://github.com/ivanceras/restq) - An alternative to graphql which parses http url to express an api query.

